/*
           panteltje downcount2srt

         Copyright (C) Jan Panteltje 2009-always

    email: panteltje@yahoo.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#define VERSION "0.1"

#include <stdio.h>
#include <stdlib.h>


#define TEXT_ARRAY_SIZE 4096


int main(int argc, char **argv)
{
int hour, minute, second;
int display_hour, display_minute, display_second, display_start_milli_second, display_end_milli_second;
int start_seconds, seconds_to_go;
int entry_number;
char text[TEXT_ARRAY_SIZE];

/* defaults */
display_start_milli_second = 0;
display_end_milli_second = 999;

/* end defaults */

/* Identify */
fprintf(stderr, "\nPanteltje(c) downcount2srt-%s\n", VERSION);

/* argument check */
if(argc != 4)
	{
	fprintf(stderr, "Usage:\n");
	fprintf(stderr, "downcount2srt hour minute second > my_movie.srt.\n");

	fprintf(stderr, "Use the created .srt file with mplayer for example like this (see man mplayer):\n");
	fprintf(stderr, "mplayer my_movie.avi -sub my_movie.srt -subfont-text-scale 50 -font /usr/share/fonts/wine/arial.ttf\n");

	exit(1);		
	}

/* get command line parameters */

hour = atoi(argv[1]);
minute = atoi(argv[2]);
second = atoi(argv[3]);
	
/* sanity checks */
if( (hour < 0) || (hour > 23) )
	{
	fprintf(stderr, "hour should be 0-23, aborting.\n");

	exit(1);
	}

if((minute < 0) || (minute > 59) )
	{
	fprintf(stderr, "minute should be 0-59, aborting\n");
	
	exit(1);
	}

if((second < 0) || (second > 59) )
	{
	fprintf(stderr, "second should be 0-59 ,aborting.\n");
	
	exit(1);
	}


start_seconds = (3600 * hour ) + (60 * minute) + second;
seconds_to_go = start_seconds;

/* info for user */
fprintf(stderr, "Start time=%02d:%02d:%02d\n", hour, minute, second);

/* ths is where we start in the movie, could be made a command line option */
display_hour = 0;
display_minute = 0;
display_second = 0;

/* srt files seem sto start with entry  1 */
entry_number = 1;

/* loop that counts down seconds and writes an .srt entry for each second */
while(1)
	{
	sprintf(text, "%02d:%02d:%02d", hour, minute, second);

/*
SRT example:

4
00:01:29,019 --> 00:01:31,294
Dieu Tout Puissant,
nous sommes enfin libres !
*/

	/* sequence number, starts at 1 */
	fprintf(stdout, "%d\r\n", entry_number);

	/* print entry */
	fprintf(stdout,\
	"%02d:%02d:%02d,%03d --> %02d:%02d:%02d,%03d\r\n",\
	display_hour, display_minute, display_second, display_start_milli_second,\
	display_hour, display_minute, display_second, display_end_milli_second);

	/* the text line(s) */
	fprintf(stdout, "%s\r\n", text);

	/* empty line ends text, everything in MSDOS format */
	fprintf(stdout, "\r\n");


	/* test for counter zero */
	seconds_to_go--;
	if(seconds_to_go < 0)
		{
		exit(0);
		}


	/* update things */
	second--;
	if(second <0)
		{
		second = 59;
		minute--;
		if(minute < 0)
			{
			minute = 59;
			hour--;
			if(hour < 0)
				{
				hour = 23;
				}
			}

		}	
	
	display_second++;
	if(display_second == 60)
		{
		display_second = 0;
		display_minute++;
		if(display_minute == 60)
			{
			display_minute = 0;
			display_hour++;
			if(display_hour == 24)
				{
				display_hour = 0;
				}
			}
		}	

	entry_number++;
	} /* end wile count down seconds */

} /* end function main */


